#@fileName <YalgaarChannelist.rb>
#@brief - <methods>
#
#Revision Log:
#     v1.0.2  : Aug 4, 2016   INITIAL OF PROGRAMMER - REVISION DETAIL_1        <- THIS IS THE LATEST REVISION	
#Description:
#YalgaarInitModule contents methods and variables and enum.. 
#
#@bug  Known Issues:
#	 1. ISSUE NAME - NONE
#		WORKAROUND - NONE
#@details Notes: NONE
#SLS MAKES NO REPRESENTATION, WARRANTY, OR CONDITION OF
#ANY KIND, EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE OR IN
#ANY COMMUNICATION WITH YOU, INCLUDING, BUT NOT LIMITED TO,
#ANY IMPLIED WARRANTIES OF MERCHANTABILITY, SATISFACTORY
#QUALITY, FITNESS FOR ANY PARTICULAR PURPOSE,
#NONINFRINGEMENT, AND THEIR EQUIVALENTS.
#SLS Propritery and Confidential 
#@copyright (C) 2016  SLS Corporation, All Rights Reserved. 
 #~ require_relative 'YalgaarInitModule'
 #!/usr/bin/env ruby
 require 'json'
 require_relative 'YalgaarInitModule'
# Namespace module for YalgaarChannelList default variables...   
 module YalgaarChannelList
	#~ include YalgaarInit
	#~ include MQTT
	include YalgaarInit
	#~ include YalgaarApis
	#yalgaarGetChannelList(message);
	#@brief - <To yalgaarGetChannelList as given length>		
	#@param  <Length> : <length for how long uuid generating>
	#DESCRIPTION:<To yalgaarGetChannelList as given length>
	def yalgaarGetChannelList(uid,lamda1,lamda2)
		if @@isConnected==true
			if uidValidation(uid)
				topic=@@clientKey+'/'+uid+'/'+uid+'$'+'0'+'$'+'channels'
				#~ puts topic
				@@client.subscribe(topic) 
				@@lChannelList=lamda1
			else
				errmesg=showErrCode(YALGAAR_108)
				lamda2.call(errmesg)	
			end	
		else
			return YALGAAR_NO_SERVER_CONNECTION	 	
		end	
	end
	#yalgaarGetUserList(message);
	#@brief - <To yalgaarGetUserList as given length>		
	#@param  <Length> : <length for how long uuid generating>
	#DESCRIPTION:<To yalgaarGetUserList as given length>
	def yalgaarGetUserList(channel,lamda1,lamda2)
		if @@isConnected==true
			 if channelValidation(channel)
				topic=@@clientKey+'/'+@@uuid+'/'+channel+'$'+'0'+'$'+'users'
				#~ puts topic
				@@client.subscribe(topic) 
				@@lUserList=lamda1
			 else	
				errmesg=showErrCode(YALGAAR_108)
				lamda2.call(errmesg)
			 end
		else
			return YALGAAR_NO_SERVER_CONNECTION	 
		end		
	end
	
end

